import { world, system, BlockPermutation, Dimension } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  const mineshaftStructureSpawner = [
    "nicothekid:structure_mineshaft_ancient",
    "nicothekid:structure_mineshaft_birch",
    "nicothekid:structure_mineshaft_oak",
    "nicothekid:structure_mineshaft_spruce",
    "nicothekid:structure_msa_arch_way_east",
    "nicothekid:structure_msa_arch_way_north",
    "nicothekid:structure_msa_arch_way_south",
    "nicothekid:structure_msa_arch_way_west",
    "nicothekid:structure_msa_way_east",
    "nicothekid:structure_msa_way_north",
    "nicothekid:structure_msa_way_south",
    "nicothekid:structure_msa_way_west",
    "nicothekid:structure_msb_ground_way_east",
    "nicothekid:structure_msb_ground_way_north",
    "nicothekid:structure_msb_ground_way_south",
    "nicothekid:structure_msb_ground_way_west",
    "nicothekid:structure_msb_way_east",
    "nicothekid:structure_msb_way_north",
    "nicothekid:structure_msb_way_south",
    "nicothekid:structure_msb_way_west",
    "nicothekid:structure_mso_ground_way_east",
    "nicothekid:structure_mso_ground_way_north",
    "nicothekid:structure_mso_ground_way_south",
    "nicothekid:structure_mso_ground_way_west",
    "nicothekid:structure_mso_way_east",
    "nicothekid:structure_mso_way_north",
    "nicothekid:structure_mso_way_south",
    "nicothekid:structure_mso_way_west",
    "nicothekid:structure_mss_way_east",
    "nicothekid:structure_mss_way_north",
    "nicothekid:structure_mss_way_south",
    "nicothekid:structure_mss_way_west"
  ]
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:structure_mineshaft_on_random_tick", {
    onRandomTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      if (mineshaftStructureSpawner.includes(block.typeId)) {
        let randomChance = Math.random() * (100.0 - 0.0) + 0.0;
        if (block.permutation.matches("nicothekid:structure_mineshaft_ancient")) {
          block.setPermutation(BlockPermutation.resolve("minecraft:air"));
          block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/am_center_01" ${blockLocation.x - 18} ${blockLocation.y - 3} ${blockLocation.z - 18}`);
        }
        if (block.permutation.matches("nicothekid:structure_mineshaft_birch")) {
          block.setPermutation(BlockPermutation.resolve("minecraft:air"));
          block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/bwm_main_01" ${blockLocation.x - 4} ${blockLocation.y - 31} ${blockLocation.z - 5}`);
        }
        if (block.permutation.matches("nicothekid:structure_mineshaft_oak")) {
          block.setPermutation(BlockPermutation.resolve("minecraft:air"));
          block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/owm_center_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
        }
        if (block.permutation.matches("nicothekid:structure_mineshaft_spruce")) {
          block.setPermutation(BlockPermutation.resolve("minecraft:air"));
          block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/swm_center_01" ${blockLocation.x - 14} ${blockLocation.y - 1} ${blockLocation.z - 14}`);
        }
        if (block.permutation.matches("nicothekid:structure_msa_arch_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 12.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 25.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 38.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 50.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 63.5) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 76.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 78.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 81.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 84) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 86.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 89.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 90.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 92.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_arch_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 12.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_north_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 25.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_north_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 38.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_north_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 50.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_north_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 63.5) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_north_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 76.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_north_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 78.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 81.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 84) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_03" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 86.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_04" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 89.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_05" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 90.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 92.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_arch_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 12.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_south_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 25.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_south_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 38.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_south_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 50.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_south_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 63.5) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_south_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 76.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_south_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 78.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 81.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 84) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_03" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 86.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_04" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 89.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_05" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 90.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 92.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_arch_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 12.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 25.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_west_02" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 38.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_west_03" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 50.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_west_04" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 63.5) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_west_05" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 76.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_west_06" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 78.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 81.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_02" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 84) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_03" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 86.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_04" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 89.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_05" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 90.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 92.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 10.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 15.3) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 20.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 25) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 30.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 35.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_07" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 40.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_08" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 45.9) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_09" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 51) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_10" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 56.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_11" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 61.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_12" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 63.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 66.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 69) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 71.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 74.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 75.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 10.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 15.3) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 20.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 25) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 30.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 35.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_07" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 40.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_08" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 45.9) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_09" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 51) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_10" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 56.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_11" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 61.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_12" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 63.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 66.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 69) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_03" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 71.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_04" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 74.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_05" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 75.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 10.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 15.3) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 20.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 25) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 30.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 35.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_07" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 40.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_08" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 45.9) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_09" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 51) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_10" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 56.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_11" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 61.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_12" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 63.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 66.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 69) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_03" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 71.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_04" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 74.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_05" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 75.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 10.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_02" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 15.3) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_03" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 20.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_04" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 25) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_05" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 30.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_06" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 35.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_07" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 40.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_08" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 45.9) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_09" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 51) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_10" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 56.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_11" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 61.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_12" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 63.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 66.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_02" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 69) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_03" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 71.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_04" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 74.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_05" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 75.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_ground_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_02" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_03" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 80.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_04" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_ground_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 40.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 60.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 80.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_ground_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 40.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_02" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 60.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_03" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 80.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_04" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_ground_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_02" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_03" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 80.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_04" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_05" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 11.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 17.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 23.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 29.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 34.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_07" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 46.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_08" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 52.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_09" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 58.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_10" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 63.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 65.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 68.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 71.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 74.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spawner_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 76.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 11.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 17.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 23.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 29.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 34.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 40.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 46.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 52.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_09" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 58.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_10" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 60.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 63.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_02" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 65.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_03" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 68.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_04" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 71.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_05" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_06" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 74.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spawner_north_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 76.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spider_north_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_zombie_north_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 11.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 17.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 23.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 29.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 34.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 40.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 46.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 52.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_09" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 58.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_10" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 60.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 63.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_02" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 65.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_03" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 68.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_04" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 71.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_05" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_06" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 74.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spawner_south_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 76.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spider_south_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_zombie_south_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 11.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_02" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 17.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_03" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 23.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_04" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 29.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_05" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 34.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_06" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_07" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 46.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_08" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 52.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_09" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 58.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_10" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 63.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_02" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 65.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_03" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 68.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_04" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 71.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_05" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_06" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 74.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spawner_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 76.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spider_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_zombie_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_ground_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 41.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 61.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 82.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 88.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 95.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 97.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_ground_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 41.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 61.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 82.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 88.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 95.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_north_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 97.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_spider_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_zombie_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_ground_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_south_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 41.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_south_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 61.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_south_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 82.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_south_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 88.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 95.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_south_02" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 97.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_spider_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_zombie_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_ground_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_west_01" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 41.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_west_02" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 61.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_west_03" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 82.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_west_04" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 88.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 95.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_west_02" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 97.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_spider_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_zombie_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 6.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 13.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 20.1) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 26.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 33.5) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 46.9) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_07" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 53.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_08" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.3) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_09" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_10" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 69.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 72.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 74.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 76.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 6.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 13.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 20.1) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 26.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 33.5) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 40.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 46.9) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 53.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 60.3) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_09" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_10" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 69.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 72.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_north_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 74.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_spider_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 76.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_zombie_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 6.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 13.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 20.1) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 26.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 33.5) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 40.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 46.9) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_07" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 53.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_08" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 60.3) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_09" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_10" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 69.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 72.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_south_02" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 74.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_spider_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 76.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_zombie_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 6.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_01" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 13.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_02" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 20.1) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_03" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 26.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_04" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 33.5) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_05" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 40.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_06" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 46.9) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_07" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 53.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_08" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 60.3) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_09" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_10" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 69.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 72.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_west_02" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 74.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_spider_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 76.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_zombie_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mss_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 10.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 16.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 21.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 27.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 32.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 37.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_07" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 43.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_08" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 48.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_09" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 54.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_10" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 59.3) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_11" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 64.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_12" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 69.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 71.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 75.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 76.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mss_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 10.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 16.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 21.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 27.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 32.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 37.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 43.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 48.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_09" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 54.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_10" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 59.3) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_11" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 64.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_12" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_north_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 69.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_north_02" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 71.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_north_03" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_north_04" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 75.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_spider_north_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 76.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_zombie_north_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mss_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 10.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 16.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 21.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 27.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 32.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 37.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 43.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 48.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_09" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 54.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_10" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 59.3) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_11" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 64.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_12" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_south_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 69.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_south_02" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 71.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_south_03" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_south_04" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 75.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_spider_south_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 76.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_zombie_south_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mss_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 10.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_02" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 16.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_03" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 21.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_04" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 27) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_05" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 32.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_06" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 37.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_07" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 43.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_08" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 48.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_09" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 54) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_10" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 59.3) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_11" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 64.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_12" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 69.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_west_02" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 71.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_west_03" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_west_04" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 75.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_spider_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 76.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_zombie_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else return;
          });
        }
      }
      else return;
    }
  });
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:structure_mineshaft_on_tick", {
    onTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      if (mineshaftStructureSpawner.includes(block.typeId)) {
        let randomChance = Math.random() * (100.0 - 0.0) + 0.0;
        if (block.permutation.matches("nicothekid:structure_mineshaft_ancient")) {
          block.setPermutation(BlockPermutation.resolve("minecraft:air"));
          block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/am_center_01" ${blockLocation.x - 18} ${blockLocation.y - 3} ${blockLocation.z - 18}`);
        }
        if (block.permutation.matches("nicothekid:structure_mineshaft_birch")) {
          block.setPermutation(BlockPermutation.resolve("minecraft:air"));
          block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/bwm_main_01" ${blockLocation.x - 4} ${blockLocation.y - 31} ${blockLocation.z - 5}`);
        }
        if (block.permutation.matches("nicothekid:structure_mineshaft_oak")) {
          block.setPermutation(BlockPermutation.resolve("minecraft:air"));
          block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/owm_center_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
        }
        if (block.permutation.matches("nicothekid:structure_mineshaft_spruce")) {
          block.setPermutation(BlockPermutation.resolve("minecraft:air"));
          block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/swm_center_01" ${blockLocation.x - 14} ${blockLocation.y - 1} ${blockLocation.z - 14}`);
        }
        if (block.permutation.matches("nicothekid:structure_msa_arch_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 12.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 25.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 38.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 50.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 63.5) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 76.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 78.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 81.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 84) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 86.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 89.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 90.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 92.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_arch_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 12.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_north_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 25.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_north_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 38.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_north_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 50.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_north_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 63.5) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_north_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 76.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_north_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 78.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 81.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 84) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_03" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 86.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_04" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 89.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_05" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 90.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 92.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_arch_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 12.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_south_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 25.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_south_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 38.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_south_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 50.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_south_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 63.5) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_south_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 76.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_south_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 78.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 81.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 84) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_03" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 86.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_04" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 89.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_05" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 90.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 92.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_arch_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 12.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 25.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_west_02" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 38.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_west_03" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 50.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_west_04" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 63.5) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_west_05" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 76.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/arched/am_west_06" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 78.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 81.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_02" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 84) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_03" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 86.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_04" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 89.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_05" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 90.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 92.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 10.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 15.3) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 20.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 25) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 30.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 35.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_07" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 40.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_08" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 45.9) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_09" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 51) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_10" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 56.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_11" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 61.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_east_12" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 63.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 66.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 69) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 71.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 74.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 75.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 10.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 15.3) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 20.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 25) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 30.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 35.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_07" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 40.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_08" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 45.9) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_09" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 51) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_10" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 56.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_11" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 61.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_north_12" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 63.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 66.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 69) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_03" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 71.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_04" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 74.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_north_05" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 75.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 10}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 10.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 15.3) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 20.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 25) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 30.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 35.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_07" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 40.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_08" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 45.9) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_09" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 51) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_10" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 56.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_11" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 61.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_south_12" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 63.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 66.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 69) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_03" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 71.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_04" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 74.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_south_05" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 75.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_south_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msa_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 10.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_02" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 15.3) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_03" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 20.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_04" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 25) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_05" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 30.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_06" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 35.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_07" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 40.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_08" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 45.9) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_09" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 51) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_10" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 56.1) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_11" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 61.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/passageway/am_west_12" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 63.8) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 66.4) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_02" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 69) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_03" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 71.6) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_04" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 74.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_station_west_05" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 75.7) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_spider_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/ancient_mineshaft/station/am_zombie_west_01" ${blockLocation.x - 10} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_ground_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_02" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_03" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 80.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_04" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_ground_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 40.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 60.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 80.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_north_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_ground_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 40.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_02" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 60.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_03" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 80.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_04" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_south_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_ground_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_02" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_03" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 80.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_04" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_vestibule_way_west_05" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 11.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 17.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 23.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 29.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 34.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_07" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 46.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_08" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 52.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_09" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 58.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_east_10" ${blockLocation.x} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 63.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 65.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 68.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 71.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 74.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spawner_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 76.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 11.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 17.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 23.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 29.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 34.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 40.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 46.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 52.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_09" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 58.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_north_10" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 60.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 63.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_02" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 65.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_03" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 68.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_04" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 71.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_05" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_north_06" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 74.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spawner_north_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 76.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spider_north_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_zombie_north_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 11.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 17.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 23.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 29.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 34.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 40.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 46.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 52.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_09" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 58.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_south_10" ${blockLocation.x - 1} ${blockLocation.y - 6} ${blockLocation.z}`);
            }
            else if (randomChance <= 60.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 63.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_02" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 65.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_03" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 68.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_04" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 71.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_05" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_south_06" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 74.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spawner_south_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 76.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spider_south_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_zombie_south_01" ${blockLocation.x - 3} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_msb_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 11.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_02" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 17.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_03" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 23.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_04" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 29.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_05" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 34.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_06" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_07" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 46.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_08" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 52.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_09" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 58.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/passageway/bwm_way_west_10" ${blockLocation.x - 6} ${blockLocation.y - 6} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 63.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_02" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 65.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_03" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 68.4) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_04" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 71.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_05" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_station_west_06" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 74.8) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spawner_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 76.0) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_spider_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else if (randomChance <= 77.2) {
              block.dimension.runCommandAsync(`structure load "nmm/birch_wood_mineshaft/station/bwm_zombie_west_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z - 3}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_ground_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 41.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 61.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 82.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 88.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 95.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 97.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_ground_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 41.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 61.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 82.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 88.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 95.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_north_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 97.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_spider_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_zombie_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_ground_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_south_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 41.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_south_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 61.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_south_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 82.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_south_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 88.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 95.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_south_02" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 97.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_spider_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_zombie_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_ground_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 20.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_west_01" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 41.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_west_02" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 61.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_west_03" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 82.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_vestibule_way_west_04" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 88.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 95.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_station_west_02" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 97.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_spider_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 100.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_vestibule_zombie_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 6.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 13.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 20.1) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 26.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 33.5) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 40.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 46.9) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_07" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 53.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_08" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 60.3) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_09" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_east_10" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 69.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 72.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 74.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else if (randomChance <= 76.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 5}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 6.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 13.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 20.1) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 26.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 33.5) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 40.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 46.9) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 53.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 60.3) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_09" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_north_10" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 7}`);
            }
            else if (randomChance <= 69.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 72.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_north_02" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 74.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_spider_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else if (randomChance <= 76.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_zombie_north_01" ${blockLocation.x - 5} ${blockLocation.y - 1} ${blockLocation.z - 11}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 6.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_01" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 13.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_02" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 20.1) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_03" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 26.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_04" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 33.5) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_05" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 40.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_06" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 46.9) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_07" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 53.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_08" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 60.3) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_09" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_south_10" ${blockLocation.x - 2} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 69.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 72.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_south_02" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 74.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_spider_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 76.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_zombie_south_01" ${blockLocation.x - 6} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mso_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 6.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_01" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 13.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_02" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 20.1) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_03" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 26.8) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_04" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 33.5) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_05" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 40.2) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_06" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 46.9) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_07" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 53.6) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_08" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 60.3) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_09" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/passageway/owm_way_west_10" ${blockLocation.x - 7} ${blockLocation.y - 1} ${blockLocation.z - 2}`);
            }
            else if (randomChance <= 69.7) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 72.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_station_west_02" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 74.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_spider_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else if (randomChance <= 76.4) {
              block.dimension.runCommandAsync(`structure load "nmm/oak_wood_mineshaft/station/owm_zombie_west_01" ${blockLocation.x - 11} ${blockLocation.y - 1} ${blockLocation.z - 6}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mss_way_east")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 10.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 16.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 21.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 27.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_05" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 32.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_06" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 37.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_07" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 43.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_08" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 48.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_09" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 54.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_10" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 59.3) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_11" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 64.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_east_12" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 69.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_east_02" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 71.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_east_03" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_east_04" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 75.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_spider_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 76.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_zombie_east_01" ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mss_way_north")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 10.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 16.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 21.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 27.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 32.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 37.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 43.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 48.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_09" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 54.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_10" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 59.3) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_11" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 64.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_north_12" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_north_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 69.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_north_02" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 71.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_north_03" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_north_04" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 75.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_spider_north_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else if (randomChance <= 76.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_zombie_north_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z - 8}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mss_way_south")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_01" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 10.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_02" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 16.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_03" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 21.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_04" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 27.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_05" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 32.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_06" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 37.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_07" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 43.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_08" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 48.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_09" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 54.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_10" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 59.3) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_11" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 64.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_south_12" ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_south_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 69.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_south_02" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 71.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_south_03" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_south_04" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 75.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_spider_south_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else if (randomChance <= 76.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_zombie_south_01" ${blockLocation.x - 4} ${blockLocation.y - 1} ${blockLocation.z}`);
            }
            else return;
          });
        }
        if (block.permutation.matches("nicothekid:structure_mss_way_west")) {
          system.run(() => {
            block.setPermutation(BlockPermutation.resolve("minecraft:air"));
            if (randomChance <= 5.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 10.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_02" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 16.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_03" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 21.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_04" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 27) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_05" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 32.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_06" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 37.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_07" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 43.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_08" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 48.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_09" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 54) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_10" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 59.3) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_11" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 64.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/passageway/swm_way_west_12" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 1}`);
            }
            else if (randomChance <= 67.0) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 69.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_west_02" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 71.4) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_west_03" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 73.6) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_station_west_04" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 75.2) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_spider_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else if (randomChance <= 76.8) {
              block.dimension.runCommandAsync(`structure load "nmm/spruce_wood_mineshaft/station/swm_zombie_west_01" ${blockLocation.x - 8} ${blockLocation.y - 1} ${blockLocation.z - 4}`);
            }
            else return;
          });
        }
      }
      else return;
    }
  });
});